#include <stdio.h>
/* Napisite funkciju int pronadji(int br, int *f, int *k) koja prima prirodan broj
  br te adrese dviju varijabli f i k. Funkcija treba broj br rastaviti na proste
  faktore te vratiti prosti faktor s najvecom kratnosti i samu kratnost kao
  varijabilne parametre, redom, u f i k. Funkcija vraća broj sastavljen od
  preostalih prostih faktora broja br, uključujući i njihovu kratnost. Ako je br
  jednak 1, funkcija mora vratiti 1, dok ostale vrijednosti ne mijenja.
*/
int pronadji(int br, int *f, int *k) {
  int i;
  int maxk = -1;
  int maxf;
  int tmp = br;

  // ako je br jednak 1, vracamo se bez promjena
  if (br == 1)
    return 1;

  // prodjemo po svim faktorima manjima od br
  // posebno, moramo provjeriti i sam br
  for (i = 2; i <= br; ++i) {
    int kratnost = 0;
    // znamo da je najmanji broj koji dijeli neki drugi broj uvijek prost!
    // prostost zato ne trebamo provjeravati
    while (br % i == 0) {
      kratnost++;
      br /= i;
    }

    // ako i nije faktor u br, preskacemo ga
    if (kratnost == 0)
      continue;

    // ako smo ovdje, kratnost nije nula
    if (kratnost > maxk) {
      maxk = kratnost;
      maxf = i;
    }
  }

  // potrebno je vratiti broj u kojem je izbacen pronadjeni faktor
  for (i = 0; i < maxk; ++i)
    tmp /= maxf;

  // podesimo povratne vrijednosti
  *f = maxf;
  *k = maxk;
  return tmp;
}

/* Napisite funkciju main u kojoj ucitavate dva prirodna broja n1 i n2.
  Koristeci funkciju iz (a) dijela, ispisite najmanji broj izmedju n1 i n2
  (ukljucujuci oba) koji ima samo jedan prost faktor. Ukoliko takvih nema,
  potrebno je ispisati odgovarajucu poruku.
*/
int main() {
  int n1, n2;
  int i;
  int pronadjen = 0;

  int f, k;

  // za testiranje prvog dijela
  /*
  int br = pronadji(2*2*3*3*3*3, &f, &k);
  printf("vraceno: %d, faktor: %d, kratnost: %d\n", br, f, k);
  */

  scanf("%d %d", &n1, &n2);
  // trazimo najveci broj pa krecemo zdesna
  for (i = n1; i <= n2; ++i) {
    int k, f;

    int br = pronadji(i, &f, &k);
    // ako ima samo jedan prost faktor, onda je dijeljenjem taj izbacen dakle,
    // br mora biti jednak 1! Broj 1 je poseban slucaj pa ga izbacujemo
    if (i != 1 && br == 1) {
      pronadjen = 1;
      break; // ne trebamo dalje racunati
    }
  }

  if (pronadjen) {
    printf("%d\n", i);
  }
  else {
    printf("Takav broj ne postoji!\n");
  }

  return 0;
}
