/* Zadatak 3a:

\begin{itemize}
  \item[(a)]
Napi\v{s}ite funkciju koja prima prirodan broj $k$ i niz od $n$ prirodnih
brojeva. Funkcija treba sortirati niz \textbf{silazno}, uz sljede\'{c}i ure\dj aj:
broj $a$ manji je od broja $b$, ako je ostatak pri dijeljenju broja $a^2$ s $k$,
manji od ostatka pri dijeljenju broja $b^2$ s $k$.
Ukoliko su ostatci jednaki, imamo standardni ure\dj aj.

  \item[(b)]
Napi\v{s}ite funkciju koja prima prirodne brojeve $k$, $m$ i niz od $n$
prirodnih brojeva (koji \textbf{ne} mora biti sortiran). Funkcija treba vratiti
ukupan broj parova susjednih elemenata u nizu, \v{c}ija je apsolutna vrijednost
razlike ve\'{c}a ili jednaka od $m$, po danom ure\dj aju iz (a), zadanom brojem $k$.
Par susjeda brojimo jednom, bez obzira na poredak indeksa.
\end{itemize}

*/

#include <stdio.h>

    /* Funkcija za usporedbu brojeva a i b, uz zadani k,
       prema zadanom uredjaju. Funkcija vraca
         -1, ako je a < b (po uredjaju),
          0, ako je a == b (po uredjaju),
          1, ako je a > b (po uredjaju). */

int usporedi(int a, int b, int k)
{
    int a2k = a*a % k, b2k = b*b % k;

    if (a2k < b2k) return -1;
    if (a2k > b2k) return 1;
        /* Ovdje je a2k == b2k. */
    if (a < b) return -1;
    if (a > b) return 1;
    return 0;
}

    /* (a) Funkcija za silazno sortiranje.
       Sortiranje izborom ekstrema, najveci na pocetak. */

void sort(int k, int n, int x[])
{
    int i, j, ind_max, temp;

    for (i = 0; i < n - 1; ++i) {
        ind_max = i;
        for (j = i + 1; j < n; ++j)
            if (usporedi(x[j], x[ind_max], k) > 0)
                ind_max = j;
        if (i != ind_max) {
            temp = x[i];
            x[i] = x[ind_max];
            x[ind_max] = temp;
        }
    }
    return;
}

    /* (b) Funkcija za broj parova. */

int parovi(int k, int m, int n, int x[])
{
    int broj = 0, i, dif;

    for (i = 1; i < n; ++i) {
            /* Gledamo par x[i - 1], x[i]. */
        dif = x[i] - x[i - 1];
        if (dif < 0) dif = -dif;
        if (usporedi(dif, m, k) >= 0) ++broj;
    }
    return broj;
}

int main(void) {
    int n = 7, k = 10, m = 5;
    int x[] = {42, 12, 55, 94, 18, 44, 67};
    int i;

    printf("\n Pocetno polje x:\n");
    for (i = 0; i < n; ++i)
        printf(" x[%d] = %d\n", i, x[i]);

        /* Prvo pozovi funkciju parovi iz (b), jer
           polje x jos nije sortirano po zadanom uredjaju. */
    printf("\n Broj trazenih parova susjeda = %d\n",
           parovi(k, m, n, x));

        /* Sortiranje polja funkcijom sort iz (a). */
    sort(k, n, x);

    printf("\n Sortirano polje x po zadanom uredjaju:\n");
    for (i = 0; i < n; ++i)
        printf(" x[%d] = %d\n", i, x[i]);

    return 0;
}
